#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <dos.h>
#include <string.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "PButV110.H"
#include "PMseV101.H"

#include "DWGame.H"
#include "DWconst.H"
#include "DWinput.H"
#include "DWmath.H"
#include "DWwin.H"
#include "DWsnds.H"

// in HKkybd.cpp
extern char CtrlFlag, UpFlag, DownFlag, LeftFlag, RightFlag,
				EscFlag, AltFlag, TabFlag, NormalOp;

extern char SFX;                // in dwsnds.cpp
extern SOUND *Sound[NUMSOUNDS];


void GenHill(int heights[640])
{
	int run, slope;

	heights[0] = random(100) + 100;
   run = random(20);
   slope = tan(random(80) * PI / 180) * (random(3) - 1);
   for (int i = 1; i < 640; i++)
   {
   	heights[i] = heights[i - 1] + slope;
      if (heights[i] > 300)
      {
      	heights[i] = 299;
         slope = -0.125;
         run = 5;
      }
      else if (heights[i] < 20)
      {
      	heights[i] = 21;
         slope = 0.125;
         run = 5;
      }
      run--;
      if (run < 0)
      {
      	run = random(20);
         slope = tan(random(80) * PI / 180) * (random(3) - 1);
      }
   }

   // Lower hill around guns

   for (int i = PLAYER_1_START - BARREL_LENGTH; i <= PLAYER_1_START + BARREL_LENGTH; i++)
   	if (heights[i] > heights[PLAYER_1_START])
			heights[i] = heights[PLAYER_1_START];

   for (int i = PLAYER_2_START - BARREL_LENGTH; i <= PLAYER_2_START + BARREL_LENGTH; i++)
   	if (heights[i] > heights[PLAYER_2_START])
			heights[i] = heights[PLAYER_2_START];
}

void DrawHill(int heights[640])
{
	clearviewport();
   setcolor(GREEN);
   for (int i = 0; i < 640; i++)
   	line(i, 479, i, 479 - heights[i]);
}

void DrawGuns(int heights[640])
{
	setcolor(LIGHTBLUE);
	setfillstyle(SOLID_FILL, LIGHTBLUE);

   bar(PLAYER_1_START - GUN_WIDTH_2, 479-heights[PLAYER_1_START] - GUN_HEIGHT,
       PLAYER_1_START + GUN_WIDTH_2, 479-heights[PLAYER_1_START]);
   pieslice(PLAYER_1_START, 479-heights[PLAYER_1_START] - GUN_HEIGHT, 0, 180, GUN_WIDTH_2);
   line(PLAYER_1_START, 479-heights[PLAYER_1_START] - GUN_HEIGHT,
        PLAYER_1_START + BARREL_LENGTH, 479-heights[PLAYER_1_START] - GUN_HEIGHT);


   setcolor(LIGHTRED);
	setfillstyle(SOLID_FILL, LIGHTRED);

   bar(PLAYER_2_START - GUN_WIDTH_2, 479-heights[PLAYER_2_START] - GUN_HEIGHT,
       PLAYER_2_START + GUN_WIDTH_2, 479-heights[PLAYER_2_START]);
   pieslice(PLAYER_2_START, 479-heights[PLAYER_2_START] - GUN_HEIGHT, 0, 180, GUN_WIDTH_2);
   line(PLAYER_2_START, 479-heights[PLAYER_2_START] - GUN_HEIGHT-1,
        PLAYER_2_START - BARREL_LENGTH, 479-heights[PLAYER_2_START] - GUN_HEIGHT-1);
}

void BlowUp(int x, int y)
{
	setcolor(RED);
   setfillstyle(SOLID_FILL, RED);
   fillellipse(x, 479-y, 15, 15);
	for (int i = 1; i <= 8; i++)
   	for (int j = 1; j <= 15; j++)
      {
      	setcolor(RED);
         circle(x, 479-y, j-1==0?15:(j-1));
         setcolor(LIGHTRED);
         circle(x, 479-y, j);
         delay(20);
      }
   setfillstyle(SOLID_FILL, BLACK);
   setcolor(BLACK);
   fillellipse(x, 479-y, 30, 30);
}

void RunGame(void)
{
	ButtonObject B;
   MouseObject M;
   char *choice;
   int p1_score=0, p2_score=0, winner;

   B.AddButton(200, 280, 275, 320, GREEN, "YES", "Y");
   B.AddButton(639-275, 280, 639-200, 320, GREEN, "NO", "N");

	do
   {
   	ShowScores(p1_score, p2_score);
   	winner = Game();
      if (winner == 1) p1_score++;
      else if (winner == 0) return;
      else p2_score++;
      clearviewport();
      settextstyle(TRIPLEX_FONT, HORIZ_DIR, 4);
      settextjustify(CENTER_TEXT, CENTER_TEXT);
      setcolor(LIGHTCYAN);
      outtextxy(320, 220, "Another round?");
      B.ShowAllButtons();
      M.ColdReset();
      M.ShowMouse();
      choice = B.TrapClick(LEFT_BUTTON);
      M.HideMouse();
   } while (choice[0] == 'Y');
   ShowScores(p1_score, p2_score);
}

int Game(void)
{
	int heights[640];

 	GenHill(heights);
   DrawHill(heights);
   DrawGuns(heights);

	int game_over = 0;
   int p1_won = 0, p2_won = 0;
	int p1_angle = 0, p1_velocity = 100, p2_angle = 180, p2_velocity = 100;
   int wind_speed = random(21) - 10;

   char string[5];

   setfillstyle(SOLID_FILL, LIGHTGRAY);
   setcolor(BLACK);
   settextstyle(SMALL_FONT, HORIZ_DIR, 4);
   settextjustify(LEFT_TEXT, CENTER_TEXT);
   bar(0, 0, 639, 29);
   setcolor(BLUE);
   moveto(10, 5);
   outtext("Angle: ");
   itoa(p1_angle, string, 10);
   outtext(string);
   moveto(110, 5);
   outtext("Velocity: ");
   itoa(p1_velocity, string, 10);
   outtext(string);
	outtextxy(5, 21, "Player 1: Humans");
   setcolor(RED);
   moveto(349, 5);
   outtext("Velocity: ");
   itoa(p2_velocity, string, 10);
   outtext(string);
   moveto(549, 5);
   outtext("Angle: ");
   itoa(p2_angle, string, 10);
   outtext(string);
   settextjustify(RIGHT_TEXT, CENTER_TEXT);
   outtextxy(634, 21, "Player 2: Aliens");
   settextjustify(LEFT_TEXT, CENTER_TEXT);
   char st1[] = "Wind: 20", st2[3];
   itoa(wind_speed, st2, 10);
   strcpy(st1, "Wind: ");
   strcat(st1, st2);
   setcolor(BLACK);
   outtextxy(285, 21, st1);

   while (!game_over)
   {
   	setcolor(LIGHTGRAY);
      setfillstyle(SOLID_FILL, LIGHTGRAY);
      fillellipse(634, 5, 2, 2);
   	setcolor(LIGHTBLUE);
      setfillstyle(SOLID_FILL, LIGHTBLUE);
      fillellipse(5, 5, 2, 2);
   	if (Process(p1_angle, p1_velocity, PLAYER_1_START, heights[PLAYER_1_START]))
			return 0;
      Shoot(p1_angle, p1_velocity, wind_speed, heights, p1_won, p2_won, 1, p2_angle);
      game_over = p1_won || p2_won;
      if (game_over) continue;
      setcolor(LIGHTGRAY);
      setfillstyle(SOLID_FILL, LIGHTGRAY);
      fillellipse(5, 5, 2, 2);
      setcolor(LIGHTRED);
      setfillstyle(SOLID_FILL, LIGHTRED);
      fillellipse(634, 5, 2, 2);
      if (Process(p2_angle, p2_velocity, PLAYER_2_START, heights[PLAYER_2_START]))
      	return 0;
      Shoot(p2_angle, p2_velocity, wind_speed, heights, p1_won, p2_won, 2, p1_angle);
      game_over = p1_won || p2_won;
   }

   if (SFX)
   	start_sound(Sound[2], 3, 0);
   if (p1_won)
   	BlowUp(PLAYER_2_START, heights[PLAYER_2_START]);
   else
   	BlowUp(PLAYER_1_START, heights[PLAYER_1_START]);

   if (p1_won) HumansWin();
   else AliensWin();

   return p1_won?1:2;
}

void ShowScores(int p1_score, int p2_score)
{
	char score[6];

	clearviewport();

   settextstyle(TRIPLEX_FONT, HORIZ_DIR, 4);
   settextjustify(CENTER_TEXT, CENTER_TEXT);
	setcolor(LIGHTCYAN);
   outtextxy(320, 220, "Scores:");

   settextstyle(SMALL_FONT, HORIZ_DIR, 5);
   setcolor(LIGHTBLUE);
   outtextxy(250, 280, "PLAYER 1");
   itoa(p1_score, score, 10);
   settextstyle(SMALL_FONT, HORIZ_DIR, 4);
   outtextxy(250, 340, score);

	settextstyle(SMALL_FONT, HORIZ_DIR, 5);
   setcolor(LIGHTRED);
   outtextxy(639-250, 280, "PLAYER 2");
   itoa(p2_score, score, 10);
   settextstyle(SMALL_FONT, HORIZ_DIR, 4);
   outtextxy(639-250, 340, score);

   setcolor(LIGHTMAGENTA);
   outtextxy(320, 474, "Press ESC to continue...");

   while (!EscFlag) ;
   while (EscFlag) ;
}

