#include <math.h>
#include <graphics.h>
#include <dos.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "DWsnds.H"
#include "DWconst.H"
#include "DWmath.H"
#include "DWinput.H"

int p1_flag, p2_flag;

extern char SFX;                // in dwsnds.cpp
extern SOUND *Sound[NUMSOUNDS];

void Explode(int x, int y, int heights[640], int p1_angle, int p2_angle, int player)
{
	setcolor(RED);
   setfillstyle(SOLID_FILL, RED);
   fillellipse(x, 479-y, 10, 10);
	for (int i = 1; i <= 4; i++)
   	for (int j = 1; j <= 10; j++)
      {
      	setcolor(RED);
         circle(x, 479-y, j-1==0?10:(j-1));
         setcolor(LIGHTRED);
         circle(x, 479-y, j);
         delay(25);
      }
   setfillstyle(SOLID_FILL, BLACK);
   setcolor(BLACK);
   fillellipse(x, 479-y, 10, 10);

   for (int i = x-10; i <= x+10; i++)
   {
   	if (y-sqrt(100-(x-i)*(x-i)) >= heights[i]) ;
      else if (y+sqrt(100-(x-i)*(x-i)) <= heights[i])
      {
      	setcolor(BLACK);
      	moveto(i, 479-heights[i]);
      	heights[i] -= 2*floor(sqrt(100-(x-i)*(x-i)));
         lineto(i, 479-heights[i]);
         setcolor(GREEN);
         line(i, 479, i, 479-heights[i]);
         if (i == PLAYER_1_START) p2_flag = 1;
         else if (i == PLAYER_2_START) p1_flag = 1;
      }
      else
      {
      	setcolor(BLACK);
      	moveto(i, 479-heights[i]);
      	heights[i] = floor(y-sqrt(100-(x-i)*(x-i)));
         lineto(i, 479-heights[i]);
			setcolor(GREEN);
         line(i, 479, i, 479-heights[i]);
         if (i == PLAYER_1_START) p2_flag = 1;
         else if (i == PLAYER_2_START) p1_flag = 1;
      }
      if (heights[i] < 1) heights[i] = 1;
   }
   UpdateGun(PLAYER_1_START, heights[PLAYER_1_START], player==1?p1_angle:p2_angle, player==1?p1_angle:p2_angle);
   UpdateGun(PLAYER_2_START, heights[PLAYER_2_START], player==2?p1_angle:p2_angle, player==2?p1_angle:p2_angle);
}

inline int min(int a, int b)
{
	return a>b?a:b;
}

void DrLine(int a, int b, int c, int d)
{
	if (a < 10 && c > 630)
   {
   	line(a, min(30, 479-b), c-640, min(30, 479-d));
      line(a+640, min(30, 479-b), c, min(30, 479-d));
   }
   else if (a > 630 && c < 10)
   {
   	line(a, min(30, 479-b), c+640, min(30, 479-d));
      line(a-640, min(30, 479-b), c, min(30, 479-d));
   }
   else
   	line(a, min(30, 479-b), c, min(30, 479-d));
}

void Shoot(int p1_angle, int p1_velocity, int wind, int heights[640], int &p1_won, int &p2_won, int player, int p2_angle)
{
	float t=0;
	int crashed=0;
   float theta=p1_angle*PI/180,
   		x0 = (player==1?PLAYER_1_START:PLAYER_2_START) + BARREL_LENGTH*cos(theta),
         y0 = heights[player==1?PLAYER_1_START:PLAYER_2_START] + BARREL_LENGTH*sin(theta) + GUN_HEIGHT,
         v0 = p1_velocity/10;
   float p_y = y0,
         p_x = x0;
   float x, y;
   float xt;
   int player_color = player==1?BLUE:RED;
   int tmp;
   int coords[TAIL_LENGTH][2];
   int i;

   for (i = 0; i < TAIL_LENGTH; i++)
   {
   	coords[i][0] = x0; coords[i][1] = y0;
   }

   p1_flag = 0;  p2_flag = 0;

   if (SFX)
   	start_sound(Sound[1], 1, 0);

   while (!crashed)
   {
   	delay(1);
   	t += 0.01;
      setcolor(player_color);
      DrLine(coords[0][0], coords[0][1], coords[1][0], coords[1][1]);
//    line(coords[0][0][0], coords[0][0][1], coords[0][1][0], coords[0][1][1]);
		for (i = 0; i < TAIL_LENGTH-1; i++)
      {
      	coords[i][0] = coords[i+1][0];
         coords[i][1] = coords[i+1][1];
      }
      x = x0 + v0*cos(theta)*t + 0.5*wind*t*t;
      xt = x;
      while (x > 639) x -= 640;
      while (x < 0) x += 640;
      y = y0 + v0*sin(theta)*t - 4.9*t*t;
      coords[TAIL_LENGTH-1][0] = floor(x);
      coords[TAIL_LENGTH-1][1] = floor(y);
      setcolor(player_color + 8);
      DrLine(coords[TAIL_LENGTH-2][0], coords[TAIL_LENGTH-2][1], coords[TAIL_LENGTH-1][0], coords[TAIL_LENGTH-1][1]);

      tmp = floor(x);
      if (heights[tmp] >= y)
      {
      	setcolor(player_color);
      	for (i = 0; i < TAIL_LENGTH-1; i++)
         {
         	DrLine(coords[i][0], coords[i][1], coords[i+1][0], coords[i+1][1]);
            delay(1);
         }
         if (SFX)
         	start_sound(Sound[2], 2, 0);
      	Explode(floor(x), floor(y), heights, p1_angle, p2_angle, player);
         crashed = 1;
         p1_won = p1_flag;
         p2_won = p2_flag;
         if ( sqrt( (x-PLAYER_1_START)*(x-PLAYER_1_START) +
                    (y-(heights[PLAYER_1_START]+GUN_HEIGHT))*(y-(heights[PLAYER_1_START]+GUN_HEIGHT)) )
					<= 10+GUN_WIDTH_2 )
      		p2_won = 1;
         if ( sqrt( (x-PLAYER_2_START)*(x-PLAYER_2_START) +
                    (y-(heights[PLAYER_2_START]+GUN_HEIGHT))*(y-(heights[PLAYER_2_START]+GUN_HEIGHT)) )
					<= 10+GUN_WIDTH_2 )
      		p1_won = 1;
      }
   }
}
