#include <iostream.h>
#include <stdlib.h>
#include <iomanip.h>
#include <conio.h>

extern "C"
{
	#include "detect.h"
	#include "smix.h"
}

#include "DWSnds.H"

int baseio, irq, dma, dma16;
SOUND *Sound[NUMSOUNDS];
char Music = 1, SFX = 1;

//exit proc
void SndExitProc(void)
{
	int i;

   for (i=0; i < NUMSOUNDS; ++i)
   	if (Sound[i] != NULL)
      	free_sound(Sound+i);

	#ifdef SHAREDEMB
    	shutdown_sharing();
	#endif
}

void loadsounds(void)
{
   if (!init_xms())
   {
   	cout << "Can not initialize extended memory\n";
      cout << "HIMEM.SYS must be installed\n";
      cout << "There will be no sounds.\n";
      cout << "Press a key...\n";
      if (getch() == 0) getch();
      Music = 0;
      SFX = 0;
      return;
   }

   cout << "Extended memory successfully initialized\n";
   cout << "Free XMS memory: " << getfreexms() << "k    ";
   if (getfreexms() < XMSREQUIRED)
   {
   	cout << "Insufficient free XMS\n";
      cout << "There will be no sounds.\n";
      cout << "Press a key...\n";
      if (getch() == 0) getch();
      Music = 0;
      SFX = 0;
      return;
   }

   cout << "Loading sounds...\n";
	#ifdef SHAREDEMB
    	init_sharing();
	#endif

   // Opens music file

   if (!open_sound_resource_file("MUSIC.DAT", 3))
   {
   	cout << "Can't load sound resource file\n";
		cout << "There will be no background music...\nPress a key...\n";
      if (getch() == 0) getch();
      Music = 0;
   }
   else
   {
   	load_sound(&(Sound[0]), "Background");
		close_sound_resource_file();
   }

   if (!open_sound_resource_file("SFX.DAT", 3))
   {
   	cout << "Can't load sound resource file\n";
		cout << "There will be no sound effects...\nPress a key...\n";
      if (getch() == 0) getch();
      SFX = 0;
   }
   else
   {
      load_sound(&(Sound[1]), "PHOTONGUN");
      load_sound(&(Sound[2]), "EXPLOSION");
		close_sound_resource_file();
   }

   atexit(SndExitProc);
}

void freesounds(void)
{
	int i;

   if (Music)
   	free_sound(Sound+0);
   if (SFX)
		for (i = 1; i < NUMSOUNDS; i++)
   		free_sound(Sound+i);
	#ifdef SHAREDEMB
    	shutdown_sharing();
	#endif
}

void init(void)
{
	cout << "-------------------------------------------\n";
   cout << "Sound Mixing Library v1.30 by Ethan Brodsky\n";
   if (!detect_settings(&baseio, &irq, &dma, &dma16))
   {
   	cout << "\n\nInvalid or non-existant BLASTER environment variable!\n";
      cout << "There will be no sounds.\n";
      cout << "Press a key...\n";
      if (getch() == 0) getch();
      Music = 0;
      SFX = 0;
      return;
   }
   else
   {
   	if (!init_sb(baseio, irq, dma, dma16))
      {
      	cout << "Error initializing sound card!\n";
         cout << "There will be no sounds.\n";
      	cout << "Press a key...\n";
      	if (getch() == 0) getch();
      	Music = 0;
      	SFX = 0;
      	return;
      }
   }

   cout << "BaseIO=" << hex << baseio << dec << "     "
   	  << "IRQ" << irq << "     "
        << "DMA8=" << dma << "     "
        << "DMA16=" << dma16 << "\n";

   cout << "DSP version " << setprecision(1) << (dspversion >> 8)
   	  << setprecision(2) << (dspversion & 0xFF) << ":  ";

   if (sixteenbit)
   	cout << "16-bit, ";
   else
   	cout << "8-bit, ";
   if (autoinit)
      cout << "Auto-initialized\n";
   else
      cout << "Single-cycle\n";

   init_mixing();
   cout << "\n";
}

void shutdown(void)

{
	shutdown_mixing();
   shutdown_sb();

   cout << "\n";
}

void InstallSounds(void)

{
	init();
	if (Music || SFX)
   	loadsounds();
}

void UnInstSounds(void)

{
	if (!Music && !SFX)
   	return;
	for (int i = 0; i < NUMSOUNDS; i++)
   	if (sound_playing(i))
      	stop_sound(i);
   shutdown();
   freesounds();
}
